<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Admin_request_control extends CI_Controller
{

  public function __construct()
  {
    parent::__construct();

    if ($this->session->userdata('prosc_admin') !== true)
      redirect(base_url(), 'refresh');
    $this->load->model('admin_request_model');
  }

  public function index()
  {
    $this->pager();
  }

  function pager($tmp = '')
  {
    $action = $this->input->get('action');
    if ($action == 'approve') return $this->supply_online();
    if (!$this->input->is_ajax_request() && strstr(current_url(), '.aspx') == '') redirect(base_url('not_found.aspx'), 'refresh');
    $data = $this->admin_request_model->_get_all() ?: [];
    $clients = $this->admin_request_model->_get_clients() ?: [];
    $users = $this->admin_request_model->_get_users() ?: [];
    $outlets = $this->admin_request_model->_get_outlets() ?: [];
    $items = $this->admin_request_model->_get_items() ?: [];
    if ($tmp == '') $this->load->view('default', ['page' => 'admin_requests', 'data' => $data, 'clients' => $clients, 'outlets' => $outlets, 'tmp' => $tmp, 'users' => $users, "items" => $items]);
    else return $this->load->view('admin/admin_requests', ['data' => $data, 'clients' => $clients, 'outlets' => $outlets, 'tmp' => $tmp, 'users' => $users, "items" => $items], true);
  }

  // function check()
  // {
  //   $receive = trim($this->input->post('message'));
  //   $voucher = trim($this->input->post('autogen'));
  //   $tag     = trim($this->input->get('tag'));

  //   if($tag == "supreme"){
  //     return [
  //       'approve'   => 1,
  //       'voucher' => $voucher,
  //       'responder' => $this->session->userdata('prosc_user'),
  //     ];  
  //   }

  //   $purpose  = 1;

  //   if ($purpose == '' OR !in_array($purpose, [0,1])) return false;

  //   if ($purpose == 1) {
  //     $data = [];
  //     foreach ($this->input->post() as $key => $value) {
  //       if (in_array($key, ['purpose', 'message']) OR !is_numeric($value) OR $value < 1) continue;
  //       $data[$key] = $value;
  //     }
  //     if (count($data) == 0 OR max($data) < 1) return false;
  //     $receive = $data;
  //   }

  //   $info = array(
  //     'message' => $receive,
  //     'purpose' => $purpose                  
  //   );  
  //   $message = json_encode($info); 
  //   return [
  //     'message'   => $message,
  //     'voucher' => $voucher,
  //     'responder' => $this->session->userdata('prosc_user')
  //   ];
  // }

  function supply_online()
  {
    $target  = trim($this->input->get('target'));
    $request = $this->admin_request_model->_get(['token' => $target, 'approve' => 0]);
    $details = json_decode($request->message, true);
    $details = $details['message'];
    $data = [];
    $stock_updates = array();
    $voucher = $this->admin_request_model->_get_voucher();
    foreach ($details as $item => $qty) {
      if (!is_numeric($qty) or $qty < 1) continue;

      $presentQty = $this->admin_request_model->_get_quantity($item);
      $price = $this->admin_request_model->_get_price($item, 'a577f519b58b533e400cf28a7464576babf92121');
      array_push($stock_updates, array('token' => $item, 'stock' => $presentQty + $qty));
      $data[] = [
        'token'    => $this->admin_request_model->_get_key(),
        'date'     => date('Y-m-d'),
        'voucher'  => $voucher,
        'price'    => $price[0],
        'item'     => $item,
        'total'    => $qty * $price[0],
        'state'    => "a577f519b58b533e400cf28a7464576babf92121",
        'outlet'   => "online_warehouse",
        'quantity' => $qty,
        'done_by'  => $_SESSION['prosc_user']
      ];
    }


    if (count($data) < 1) exit(json_encode(['status' => 'error', 'message' => 'Approval Failed, No valid products found']));

    if (!$this->admin_request_model->_put_warehouse($stock_updates))
      exit(json_encode(['status' => 'error', 'message' => 'An unknown error occured when creating supply']));

    if (!$this->admin_request_model->_post_supply($data))
      exit(json_encode(['status' => 'error', 'message' => 'An unknown error occured when creating supply']));

    $this->admin_request_model->_put([
      'responder' => $_SESSION['prosc_user'],
      'approve'   => 1
    ], $target);

    $this->session->set_flashdata('prosc_message', 'Request Approved, Generated Supply ID: <b>' . $voucher . '</b>');
    echo json_encode(['status' => 'success', 'message' => base_url('ipanel/supply.aspx')]);
  }

  function supply_warehouse()
  {
    $target  = trim($this->input->get('target'));
    $request = $this->admin_request_model->_get(['token' => $target, 'approve' => 0]);

    $outlet  = $this->admin_request_model->_get_outlet(['token' => $request->warehouse]);
    if (!$request or !$outlet) exit(json_encode(['status' => 'error', 'message' => 'Request Error! Invalid parameters received']));
    $details = json_decode($request->message, true);
    $details = $details['message'];
    $data = [];
    $voucher = $this->admin_request_model->_get_voucher();
    foreach ($details as $item => $qty) {
      if (!is_numeric($qty) or $qty < 1) continue;

      $price = $this->admin_request_model->_get_price($item, 'a577f519b58b533e400cf28a7464576babf92121');
      $data[] = [
        'token'    => $this->admin_request_model->_get_key(),
        'date'     => date('Y-m-d'),
        'voucher'  => $voucher,
        'price'    => $price[0],
        'item'     => $item,
        'total'    => $qty * $price[0],
        'state'    => $outlet->state,
        'outlet'   => $outlet->token,
        'quantity' => $qty,
        'done_by'  => $_SESSION['prosc_user']
      ];
    }

    if (count($data) < 1) exit(json_encode(['status' => 'error', 'message' => 'Approval Failed, No valid products found']));

    if (!$this->admin_request_model->_post_supply($data))
      exit(json_encode(['status' => 'error', 'message' => 'An unknown error occured when creating supply']));

    $this->admin_request_model->_put([
      'responder' => $_SESSION['prosc_user'],
      'approve'   => 1
    ], $target);

    $this->session->set_flashdata('prosc_message', 'Request Approved, Generated Supply ID: <b>' . $voucher . '</b>');
    echo json_encode(['status' => 'success', 'message' => base_url('ipanel/supply.aspx')]);
  }
  function supply()
  {
  }

  function update()
  {
    $target = trim($this->input->get('target'));
    if (!$this->admin_request_model->_get(['token' => $target])) exit(json_encode(['status' => 'error', 'message' => 'A fatal error has occured. <br />Please refresh and try again']));
    $data = $this->check();
    if (!$data) exit(json_encode(['status' => 'error', 'message' => 'Fill in all fields']));
    if (!$this->admin_request_model->_put($data, $target))
      exit(json_encode(['status' => 'error', 'message' => 'An unknown error occured and the update failed']));

    if (trim($this->input->get('tag')) == "supreme");
    $info = $this->supply();

    echo (json_encode(['status' => 'success', 'message' => $this->pager('dump')]));
  }




  public function open($token)
  {
    $data = $this->admin_request_model->_get(['token' => $token]);
    // load a view to display this data
  }


  public function edit($token)
  {
    $data = $this->admin_request_model->_get(['token' => $token]);
    // load a form view and handle form submission to update the data
  }

  public function delete($token)
  {
    $this->admin_request_model->_drop(['token' => $token]);
    // redirect to a relevant page
  }


  // public function invoice($token) {
  //   $data = $this->admin_request_model->_get(['token'=>$token]);
  //   // generate an invoice
  // }


}
