<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Login extends CI_Controller
{

  public function __construct()
  {
    parent::__construct();
    if (strstr(current_url(), 'signout') == '' && strstr(current_url(), '/theme') == '' && $this->session->userdata('prosc_user') != null)
      redirect(base_url('ipanel'), 'refresh');

    $_SESSION['chart_toggle'] = ($this->input->get('chart_toggle') == 'yearly') ? "yearly" : "monthly";
    $this->load->model('login_model');
  }

  public function index()
  {
    if ($this->input->get('k') === 'forgot_password')
      $this->forgot();
    else
      $this->load->view('login');
  }

  function signin($user = '', $pass = '')
  {
    if ($this->session->userdata('prosc_user') != '')
      redirect(base_url(), 'refresh');

    $user = $this->input->post('miuser') ?: $user;
    $pass = $this->input->post('mipass') ?: $pass;
    if ($user == null && $pass == null) exit(json_encode(['status' => 'error', 'message' => 'Enter username and password']));
    if ($user == null) exit(json_encode(['status' => 'error', 'message' => 'Enter username']));
    if ($pass == null) exit(json_encode(['status' => 'error', 'message' => 'Enter password']));

    $login = $this->login_model->login($user, $pass);
    if (!$login) exit(json_encode(['status' => 'error', 'message' => 'No matching record for supplied login details']));
    if ($login->status != 0) exit(json_encode(['status' => 'error', 'message' => 'Access Denied!']));
    if ($login->type != 3) {
      $check = $this->login_model->check($login->warehouse);
      if (!$check) exit(json_encode(['status' => 'error', 'message' => 'Login Failed! <br />No station assigned to user <br />Please contact admin']));
    }

    $_SESSION['prosc_name'] = $login->name;
    if ($login->type == 0) $_SESSION['prosc_admin'] = true;
    if ($login->type != 0) $_SESSION['prosc_outlet'] = true;
    $_SESSION['prosc_warehouse'] = $login->warehouse;
    $_SESSION['prosc_user'] = $login->token;
    $_SESSION['prosc_mail'] = $login->email;
    $_SESSION['prosc_image'] = $login->photo;
    $_SESSION['prosc_username'] = $login->username;
    $_SESSION['prosc_type'] = $login->type;
    echo json_encode(['status' => 'success', 'message' => 'Logged in. Redirecting...']);
  }

  function forgot()
  {
    if (isset($_SESSION['home'])) {
      unset($_SESSION['home']);
      redirect(base_url(), 'refresh');
    }
    if (!isset($_GET['action']))
      $this->load->view('password_reset');

    if ($this->input->get('action') == 'cancel') {
      $_SESSION['page'] = '';
    } elseif ($this->input->get('action') == 'email') {
      $mail = trim($this->input->post('mimail')) ?: $this->session->userdata('mail');
      if ($mail == '' or !filter_var($mail, FILTER_VALIDATE_EMAIL)) exit(json_encode(['status' => 'error', 'message' => 'Invalid Email Supplied']));
      $user = $this->login_model->get_email($mail);
      if (!$user) exit(json_encode(['status' => 'error', 'message' => 'Email does not match any records. <br>Please check for typing errors']));

      $settings = $this->login_model->settings();

      $code = strtoupper(substr(bin2hex(random_bytes(16)), 0, 6));

      $subject = "Password Reset";
      $message = $this->load->view('ionic_mail', ['user' => $user, 'code' => $code, 'settings' => $settings], true);

      $config['protocol']     = 'smtp';
      $config['smtp_host']    = 'ssl://xcelapp.test.gurugeeksroyalty.biz';
      $config['smtp_port']    = '465';
      $config['smtp_user']    = 'noreply@xcelapp.test.gurugeeksroyalty.biz';
      $config['smtp_pass']    = 'Xceltest12';
      $config['smtp_timeout'] = '7';
      $config['charset']      = 'iso-8859-1';
      $config['mailtype']     = 'html';
      $config['wordwrap']     = TRUE;
      $this->load->library('email', $config);
      $this->email->from('noreply@xcelapp.test.gurugeeksroyalty.biz', 'XCEL');
      $this->email->to($mail);
      $this->email->subject($subject);
      $this->email->message($message);

      $email = $this->email->send();
      if (!$email) exit(json_encode(['status' => 'error', 'message' => 'Failed to send password reset email']));

      $_SESSION['page'] = 'code';
      $_SESSION['code'] = $code;
      $_SESSION['user'] = $user->token;
      $_SESSION['uuid'] = $user->username;
      $_SESSION['mail'] = $mail;
      echo json_encode(['status' => 'success', 'message' => 'Email Sent!']);
    } elseif ($this->input->get('action') == 'code') {
      $code = $this->input->post('micode');

      if (!isset($_SESSION['code']) or $code != $_SESSION['code']) exit(json_encode(['status' => 'error', 'message' => 'Code is invalid']));

      $_SESSION['page'] = 'password';
      echo json_encode(['status' => 'success', 'message' => 'Verification Successful']);
    } elseif ($this->input->get('action') == 'password') {
      $p1 = $this->input->post('p1');
      $p2 = $this->input->post('p2');

      if ($p1 != $p2) exit(json_encode(['status' => 'error', 'message' => 'Passwords do not match']));

      $this->login_model->_put(['password' => password_hash("GG$p1", PASSWORD_DEFAULT)]);
      $_SESSION['home'] = true;
      unset($_SESSION['code']);
      unset($_SESSION['mail']);
      unset($_SESSION['page']);
      unset($_SESSION['user']);
      unset($_SESSION['uuid']);
      echo json_encode(['status' => 'success', 'message' => 'Password reset successful <br />Redirecting...']);
    }
  }

  function theme()
  {
    $color = $this->input->get('k');
    $this->load->helper('cookie');
    set_cookie('xcel_theme', $color, 21474836);
    echo 'Themed!';
  }

  function signout()
  {
    session_destroy();
    session_unset();
    unset($_SESSION);
  }
}
