<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Message_control extends CI_Controller
{

  public function __construct()
  {
    parent::__construct();

    if ($this->session->userdata('prosc_user') == '') redirect(base_url(), 'refresh');

    $this->load->helper('form');
    $this->load->model('message_model');
    $this->load->model('complaints_model');
  }

  public function index()
  {
    $this->pager();
  }

  function pager($tmp = '')
  {
    $target = $this->input->get('token');
    if ((!$this->input->is_ajax_request() && strstr(current_url(), 'aspx') == '')) redirect(base_url('not_found.aspx'), 'refresh');
    $data = $this->message_model->_get(['token' => $target]) ?: [];
    if ($tmp == '') $this->load->view('default', ['page' => 'messages', 'data' => $data, 'tmp' => $tmp]);
    else return $this->load->view('admin/messages', ['data' => $data, 'tmp' => $tmp], true);
  }

  function check()
  {
    $reply  = trim($this->input->post('reply'));
    if ($reply == '')
      return false;

    return [
      'reply'    => $reply,
    ];
  }

  function update()
  {
    $target = trim($this->input->get('target'));
    $data = $this->check();
    if (!$data) exit(json_encode(['status' => 'error', 'message' => 'Fill in all fields']));

    if (!$this->message_model->_put($data, $target))
      exit(json_encode(['status' => 'error', 'message' => 'An unknown error occured and the update failed']));

    echo (json_encode(['status' => 'success', 'message' => $this->pager('dump')]));
  }

  function delete()
  {
    $target = trim($this->input->get('token'));
    if (!$this->message_model->_get(['token' => $target])) exit(json_encode(['status' => 'error', 'message' => 'A fatal error has occured. <br />Please refresh and try again']));

    $this->message_model->_drop($target);
    $this->session->set_flashdata('prosc_message', 'Record Deleted');
    exit(json_encode(['status' => 'success', 'message' => '']));
  }
}
