<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Notifications_control extends CI_Controller {
  
  public function __construct()
  {
    parent::__construct();

    if ($this->session->userdata('prosc_user') == '')
      redirect(base_url(), 'refresh');
  }

  public function index()
  {
    $this->pager();
  }

  function pager($tmp='')
  {
    // $outlet = $this->notification_model->_get_outlet($_SESSION['prosc_warehouse']);
    if ((!$this->input->is_ajax_request() && strstr(current_url(), 'aspx') == '')) redirect(base_url('not_found.aspx'), 'refresh');
    $data = $this->notification_model->_get_all() ?: [];
    $stock = $this->notification_model->_get_stock() ?: [];
    $outlet = $this->notification_model->_get_outlets() ?: [];
    if ($tmp == '') $this->load->view('default', ['page'=>'notifications', 'data'=>$data, 'lows'=>$stock, 'outlet'=>$outlet, 'tmp'=>$tmp]);
    else return $this->load->view('admin/notifications', ['data'=>$data, 'lows'=>$stock, 'outlet'=>$outlet, 'tmp'=>$tmp], true);
  }

  function check()
  {
    $name  = trim($this->input->post('name')) ?: trim($this->input->post('autogen'));
    $addr  = trim($this->input->post('address'));
    $state = trim($this->input->post('state'));
    if ($name == '' OR $addr == '' OR $state == '')
      return false;
    
    return [
      'name'    => $name,
      'type'    => 1,
      'address' => $addr,
      'state'   => $state
    ];
  }

  function create()
  {
    $data = $this->check();
    if ( ! $data) exit(json_encode(['status'=>'error', 'message'=>'Fill in all fields']));
    
    if ( ! $this->notification_model->_post($data))
      exit(json_encode(['status'=>'error', 'message'=>'An unknown error occured and the insertion operation failed']));

    echo (json_encode(['status'=>'success', 'message'=>$this->pager('dump')]));
  }

  function update()
  {
    $target = trim($this->input->get('target'));
    if ( ! $this->notification_model->_get(['token'=>$target])) exit(json_encode(['status'=>'error', 'message'=>'A fatal error has occured. <br />Please refresh and try again']));
    $data = $this->check();
    if ( ! $data) exit(json_encode(['status'=>'error', 'message'=>'Fill in all fields']));

    if ( ! $this->notification_model->_put($data, $target))
      exit(json_encode(['status'=>'error', 'message'=>'An unknown error occured and the update failed']));

    echo (json_encode(['status'=>'success', 'message'=>$this->pager('dump')]));
  }

  function delete()
  {
    $target = trim($this->input->get('token'));
    if ( ! $this->notification_model->_get(['token'=>$target])) exit(json_encode(['status'=>'error', 'message'=>'A fatal error has occured. <br />Please refresh and try again']));

    $this->notification_model->_drop($target); 
    $this->session->set_flashdata('prosc_message', 'Record Deleted');
    exit(json_encode(['status'=>'success', 'message'=>'']));
  }

  function popup()
  {
    if ( ! $this->input->is_ajax_request()) {
      $pagedata['heading'] = 'Hold on!';
      $pagedata['message'] = 'The page you tried to reach, restricts direct access.';
      $this->load->view('errors/html/error_404', $pagedata);
    }
    $data['data'] = [];
    $file = $this->notification_model->_get_outlets();
    $states = $this->notification_model->_get_states(); $s = [];
    if ($file) $data['data'] = $file;
    $data['states'] = $states;
    $this->load->view('popups/admin/notifications', $data);
  }
}
