
<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Waybill_online_control extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();

        if ($this->session->userdata('prosc_warehouse') == "")
            redirect(base_url(), 'refresh');

        $this->load->model('waybill_online_model');
    }

    public function index()
    {
        $this->pager();
    }

    function pager($tmp = '')
    {
        $target = $this->input->get('target');
        $token = $this->input->get('token');
        if (!$this->input->is_ajax_request() && strstr(current_url(), '.aspx') == '') redirect(base_url('not_found.aspx'), 'refresh');
        $data = [];
        if ($tmp == '') $this->load->view('default', ['page' => 'waybill_online', 'data' => $data, 'target' => $target, 'token' => $token, 'tmp' => $tmp]);
        else return $this->load->view('admin/waybill_online', ['data' => $data, 'target' => $target, 'token' => $token, 'tmp' => $tmp], true);
    }

    function check($voucher, $shippping_token)
    {
        $items = [];
        $selectedTokens = [];
        $shipping = $this->waybill_online_model->_get_sales($voucher, true) ?: [];

        foreach ($shipping as $item) {
            $item_id  = $this->input->post($item['item']);
            if ($item_id) {
                $items[] = $item_id;
                if (in_array($item_id, $item)) {
                    $items[] = $item['token'];
                }
                $selectedTokens[] = $item['token'];
            }
        }
        $name  = trim($this->input->post('name'));
        $phone = trim($this->input->post('phone'));
        $state  = trim($this->input->post('state'));
        if ($name == '' or $phone == '' or $state == '') return false;
        if (!ctype_alpha(str_replace(' ', '', $name))) return 'Driver name is invalid';
        if (!is_numeric($phone) or strlen($phone) != 11) return 'Phone number must be 11 digits';


        $data = [
            'items'    => implode(' ', $items),
            'state'     => $state,
            'voucher' => $voucher,
            'phone'    => $phone,
            'driver'   => $name,
            'delivery_address' => $shipping[0]['delivery_address'],
            'shipping_token'   => implode(' ', $selectedTokens),
            'delivery' => 0,
        ];

        return $data;
    }


    function create()
    {
        $voucher = $this->input->get('voucher');
        $shipping_token = $this->input->get('token');

        $data = $this->check($voucher, $shipping_token);
        if (!$data) exit(json_encode(['status' => 'error', 'message' => 'Fill in all fields']));
        if (!is_array($data)) exit(json_encode(['status' => 'error', 'message' => $data]));

        $target = $this->waybill_online_model->_post($data);
        if (!$target) exit(json_encode(['status' => 'error', 'message' => 'An unknown error occured and the operation failed']));
        $items = explode(' ', $data['items']);
        $this->waybill_online_model->_mod($target, $items, $voucher);
        $this->waybill_online_model->_mod_shipping($target, $items);

        // echo (json_encode(['status' => 'success', 'message' => base_url("generate/invoice.aspx?action=waybill&target=" . $items[0])]));
        echo (json_encode(['status' => 'success', 'message' => $this->pager('dump')]));
    }



    function popup()
    {
        if (!$this->input->is_ajax_request()) {
            $pagedata['heading'] = 'Hold on!';
            $pagedata['message'] = 'The page you tried to reach, restricts direct access.';
            $this->load->view('errors/html/error_404', $pagedata);
        }
        $target = $this->input->get('voucher');
        $token = $this->input->get('token');
        $waybill_data = ['data' => ''];
        $waybill_data['states'] = $this->waybill_online_model->_get_states() ?: [];


        $waybill_data['customers'] = $this->waybill_online_model->_get_customers() ?: [];
        $waybill_data['items'] = $this->waybill_online_model->_get_items() ?: [];
        $waybill_data['sales'] = $this->waybill_online_model->_get_sales($target);
        $waybill_data['voucher'] = $target;
        $waybill_data['token'] = $token;
        $this->load->view('popups/admin/waybill_online', $waybill_data);
    }
}
