
<?php
defined('BASEPATH') or exit('No direct script access allowed');

class Waybills_control extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();

        if ($this->session->userdata('prosc_warehouse') == "")
            redirect(base_url(), 'refresh');

        $this->load->model('waybill_model');
    }

    public function index()
    {
        $this->pager();
    }

    function pager($tmp = '')
    {
        if (!$this->input->is_ajax_request() && strstr(current_url(), '.aspx') == '') redirect(base_url('not_found.aspx'), 'refresh');

        $toggle = $this->input->get("driver");
        $data['tmp'] = $tmp;
        $data['file'] = $this->waybill_model->_get(['token' => $this->input->get('target')]);
        $data['page'] = $toggle ? "waybill_supply" : 'waybill';
        if ($toggle) {
            $data['waybill_data'] = ($this->waybill_model->_get_temps($this->input->get('target')));
        } else {
            $data['waybill_data'] = $this->waybill_model->_get_all() ?:  [];
        }
        $data['states'] = $this->waybill_model->_get_states() ?: [];

        if ($tmp == '') $this->load->view('default', ['page' => $data['page'], 'data' => $data]);
        else return $this->load->view("admin/" . $data['page'], $data, true);
    }

    function check()
    {
        $checkedItems = $this->input->post('token');
        $vouchers = $this->input->post('voucher');
        $items = $this->input->post('items');

        // Proceed with name validations
        $name = trim($this->input->post('driver'));
        $phone = trim($this->input->post('phone'));
        $state = trim($this->input->post('state'));

        // if ($name == '' || $phone == '' || $state == '') {
        //     return 'Operation failed! Please fill in all fields';
        // }

        // if (!ctype_alpha(str_replace(' ', '', $name))) {
        //     return 'Driver name is invalid';
        // }

        // if (!is_numeric($phone) || strlen($phone) != 11) {
        //     return 'Phone number must be 11 digits';
        // }


        // Check if there are any selected items
        if (empty($checkedItems)) {
            return 'Operation failed! No valid selections were made';
        }

        // Initialize an array to store unique vouchers
        $uniqueVouchers = [];
        $waybillItems = [];

        // Loop through checked items and their corresponding vouchers
        foreach ($checkedItems as $index => $item) {
            // Get the corresponding voucher for this item
            $voucher = isset($vouchers[$index]) ? $vouchers[$index] : '';
            $Wbitem = isset($items[$index]) ? $items[$index] : '';

            // Check if the voucher for this item is empty
            if (empty($voucher)) {
                return 'Operation failed! Some items do not have vouchers';
            }

            // Add the voucher to the array if it's not already there
            if (!in_array($voucher, $uniqueVouchers)) {
                $uniqueVouchers[] = $voucher;
            }

            // Store the item associated with the checked checkbox
            $waybillItems[] = $Wbitem;
        }


        // If there is more than one unique voucher, throw an error
        if (count($uniqueVouchers) > 1) {
            return 'Operation failed! Please select items with the same voucher';
        }

        $shippingTokens = [];


        // foreach ($checkedItems as $token) {
        //     $getSalesDetails = $this->waybill_model->_get_details(['token' => $token]);
        //     if (!$getSalesDetails) {
        //         foreach ($waybillItems as $item) {
        //             $getSupplyDetails = $this->waybill_model->_get_supply_details(['token' => $token]);

        //             $supplyDetails = [
        //                 'sales_id' => $token,
        //                 'order_id' => $getSupplyDetails->voucher,
        //                 'waybill' => '',
        //                 'customer' => $getSupplyDetails->outlet,
        //                 'delivery_address' => $getSupplyDetails->state,
        //                 'item' => $item->item,
        //                 'quantity' => $item->quantity,
        //                 'shipment_status' => 'Shipment Created',
        //                 'status' => 0,
        //             ];

        //             if (!$supplyDetails) exit(json_encode(['status' => 'error', 'message' => 'Data not found']));
        //             $result = $this->waybill_model->_post_shipping($supplyDetails, 'er_supply');
        //             if (!$result) exit(json_encode(['status' => 'error', 'message' => 'An unknown error occured and the insertion operation failed']));
        //             $shippingTokens[] = $result;
        //         }
        //     } else {
        //         foreach ($waybillItems as $item) {
        //             $order_xtral = $this->waybill_model->_get_sales_xtal(['voucher' => $getSalesDetails->voucher], true);
        //             $dataArray = json_decode($order_xtral->shipping, true);

        //             $result = array(
        //                 'city' => $dataArray['city'],
        //                 'address' => $dataArray['address'],
        //                 'country' => $dataArray['country'],
        //                 'zipcode' =>  $dataArray['zipcode']
        //             );

        //             $itemDetails = [
        //                 'sales_id' => $token,
        //                 'order_id' => $getSalesDetails->voucher,
        //                 'customer' => $getSalesDetails->customer,
        //                 'delivery_address' => implode(' ', $result),
        //                 'item' => $item->item,
        //                 'quantity' => $item->quantity,
        //                 'shipment_status' => 'Shipment Created',
        //                 'status' => 0,
        //             ];


        //             if (!$itemDetails) exit(json_encode(['status' => 'error', 'message' => 'Data not found']));
        //             $result = $this->waybill_model->_post_shipping($itemDetails, 'er_sales');
        //             if (!$result) exit(json_encode(['status' => 'error', 'message' => 'An unknown error occured and the insertion operation failed']));
        //             $shippingTokens[] = $result;
        //         }
        //     }
        // }


        // Construct $data array
        // $data = [
        //     'items' => implode(' ', $waybillItems),
        //     'state' => $state,
        //     'phone' => $phone,
        //     'driver' => $name,
        //     'voucher' => $uniqueVouchers[0], // Use the first (and only) unique voucher
        //     'shipping_token'   => implode(' ', $shippingTokens),
        //     'delivery' => 0
        // ];


        return $waybillItems[0];
    }


    function deliver($target, $items, $voucher)
    {
        if (!$this->waybill_model->_mod($target, $items, $voucher)) exit(json_encode(['status' => 'error', 'message' => 'An unknown error occured while processing Supply']));
        if (!$this->waybill_model->_mod_shipping($target, $items)) exit(json_encode(['status' => 'error', 'message' => 'An unknown error occured while processing Supply']));
    }

    function create()
    {
        $data = $this->check();
        if (!$data) exit(json_encode(['status' => 'error', 'message' => 'Fill in all fields']));
        if (!is_array($data)) exit(json_encode(['status' => 'error', 'message' => $data]));

        $target = $this->waybill_model->_post($data);
        if (!$target) exit(json_encode(['status' => 'error', 'message' => 'An unknown error occured and the operation failed']));
        // $this->deliver($data['items'], $target);
        $items = explode(' ', $data['items']);
        $voucher = $data['voucher'];
        $this->deliver($target, $items, $voucher);

        echo (json_encode(['status' => 'success', 'message' => base_url("generate/invoice.aspx?action=waybill&target=$target")]));
    }

    function update()
    {
        $token = $this->input->get('token');
        $action = trim($this->input->get('action'));
        if ($action == 'approve') {
            $this->waybill_model->_put(['delivery' => 1], $token);
            exit(json_encode(['status' => 'success', 'message' => $this->pager('dump')]));
        }
        $data = $this->check();
        if (!$this->waybill_model->_get(['token' => $token])) exit(json_encode(['status' => 'error', 'message' => 'A fatal error has occured. <br />Please refresh and try again']));
        if (!$data) exit(json_encode(['status' => 'error', 'message' => $data]));
        if (!is_array($data)) exit(json_encode(['status' => 'error', 'message' => $data]));

        if (!$this->waybill_model->_put($data, $token))
            exit(json_encode(['status' => 'error', 'message' => 'An unknown error occured and the update failed']));

        $this->deliver($data['items'], $token);
        echo (json_encode(['status' => 'success', 'message' => base_url("generate/invoice.aspx?action=waybill&target=$token")]));
    }

    function delete()
    {
        $target = trim($this->input->get('token'));
        if (!$this->waybill_model->_get(['token' => $target])) exit(json_encode(['status' => 'error', 'message' => 'A fatal error has occured. <br />Please refresh and try again']));

        $this->waybill_model->_drop($target);
        $this->session->set_flashdata('prosc_message', 'Record Deleted');
        echo (json_encode(['status' => 'success', 'message' => $this->pager('dump')]));
    }

    function popup()
    {
        if (!$this->input->is_ajax_request()) {
            $pagedata['heading'] = 'Hold on!';
            $pagedata['message'] = 'The page you tried to reach, restricts direct access.';
            $this->load->view('errors/html/error_404', $pagedata);
        }
        $target = $this->input->get('token');
        $data = ['data' => ''];
        $file = $this->waybill_model->_get(['token' => $target]);
        if ($file) $data['data'] = $file;
        $this->load->view('popups/admin/waybill', $data);
    }
}
