<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Online_inventory_model extends CI_Model
{

    function __construct()
    {
        parent::__construct();
    }

    function _get($params)
    {
        $this->db->where(['status' => 0]);
        $user = $this->db->get_where('er_outlet_store', $params);
        if (!($user->num_rows() > 0)) return false;
        return $user->row();
    }

    // function _get_outlet($token)
    // {
    //     $outlet = $this->db->get_where('er_warehouse', ['token' => $token]);
    //     if (!($outlet->num_rows() > 0)) return false;
    //     return $outlet->row();
    // }

    // function _get_staff($token)
    // {
    //     $staff = $this->db->get_where('er_admin', ['warehouse' => $token]);
    //     if (!($staff->num_rows() > 0)) return false;
    //     return $staff->row('name') . ' &middot; ' . $staff->row('phone');
    // }

    function _get_allx($param)
    {
        $store = $this->db->get_where('er_outlet_store', ['warehouse' => $param, 'status' => 0]);
        if (!($store->num_rows() > 0)) return false;
        return $store->result_array();
    }

    function _get_all()
    {
        $this->db->order_by('name');
        $items = $this->db->get_where("er_online_warehouse", ["status" => 0]);
        if (!($items->num_rows() > 0)) return [];
        return $items->result_array();
    }

    // function _get_returns()
    // {
    //     $data = [];
    //     $outlet = $this->session->userdata('prosc_warehouse');
    //     $this->db->select('item, SUM(quantity) AS quantity');
    //     if (!isset($_SESSION['prosc_admin'])) $this->db->where("(`outlet`='$outlet' OR `outlet`='')");
    //     if (isset($_SESSION['prosc_inventory_y'])) $this->db->where("created_at <=", $_SESSION['prosc_inventory_y']);
    //     $items = $this->db->get_where('er_returns', ['status' => 0]);

    //     if (!$items->num_rows() > 0) return [];
    //     foreach ($items->result_array() as $row) {
    //         $data[$row['item']] = $row['quantity'];
    //     }
    //     return $data;
    // }

    // function _aggregate($outlet)
    // {
    //     $items = $this->_get_items(['status' => 0]);
    //     $data = [];
    //     $store = $this->_get_allx($outlet);
    //     if ($store) {
    //         foreach ($store as $row) {
    //             $qty = $this->_get_sum('er_supply', 'quantity', ['outlet' => $outlet, 'item' => $row['item'], 'status' => 0]);
    //             $sqty = $this->_get_sum('er_sales', 'quantity', ['warehouse' => $outlet, 'item' => $row['item'], 'status' => 0]);
    //             $data[$row['item']] = [
    //                 'id' => $row['id'],
    //                 'quantity' => $qty - $sqty
    //             ];
    //         }
    //     }
    //     if ($items) {
    //         foreach ($items as $row) {
    //             if (array_key_exists($row['token'], $data)) continue;
    //             $qty = $this->_get_sum('er_supply', 'quantity', ['outlet' => $outlet, 'item' => $row['token']]);
    //             $qty -= $this->_get_sum('er_sales', 'quantity', ['warehouse' => $outlet, 'item' => $row['token']]);
    //             $this->_post([
    //                 'item'      => $row['token'],
    //                 'quantity'  => $qty,
    //                 'warehouse' => $outlet
    //             ]);
    //         }
    //     }
    //     if (count($data) > 0) $this->db->update_batch('er_outlet_store', $data, 'id');
    // }

    // function _get_items($params = '')
    // {
    //     $this->db->select('name, min_stock, token');
    //     $items = $this->db->get('er_items');
    //     if (!($items->num_rows() > 0)) return false;
    //     $data = [];
    //     foreach ($items->result_array() as $row) {
    //         $data[$row['token']] = $row;
    //     }
    //     return $data;
    // }

    // function _get_cats() 
    // {
    //   $items = $this->db->get_where('er_categories', ['status'=>0]);
    //   if ( ! ($items->num_rows() > 0)) return false;
    //   return $items->result_array();
    // }

    function _get_children($token)
    {
        $this->db->order_by('name');
        $items = $this->db->get_where("er_online_warehouse", ["category" => $token]);
        if (!($items->num_rows() > 0)) return [];
        return $items->result_array();
    }

    function _get_cats()
    {
        $this->db->order_by('name ASC');
        $cats = $this->db->get_where('er_categories', ['status' => 0]);
        $data = [];
        if (!($cats->num_rows() > 0)) return false;
        foreach ($cats->result_array() as $row) {
            $items = $this->_get_children($row['token']);
            foreach ($items as $val) {
                $price = json_decode($val['price'], true) ?? ['a577f519b58b533e400cf28a7464576babf92121' => [0, 0]];
                $price = $price['a577f519b58b533e400cf28a7464576babf92121'];
                $data[$val['token']] = [
                    'token'      => $val['token'],
                    'category'   => $row['name'],
                    'name'       => $val['name'],
                    'stock'       => $val['stock'],
                    'min_stock'       => $val['min_stock'],
                    'discount'       => $val['discount'],
                    'cost_price' => $price[1],
                    'sale_price' => $price[0]
                ];
            }
        }
        return $data;
    }

    // function _get_outlets()
    // {
    //     $this->db->order_by('type ASC, name ASC');
    //     $outlets = $this->db->get_where('er_warehouse', ['status' => 0, 'id !=' => 1]);
    //     if (!($outlets->num_rows() > 0)) return false;
    //     return $outlets->result_array();
    // }

    // function _get_states()
    // {
    //     $outlets = $this->db->get_where('er_nigeria_state', ['status' => 0]);
    //     if (!($outlets->num_rows() > 0)) return false;
    //     return $outlets->result_array();
    // }

    function _get_sum($table, $col, $filter = '')
    {
        $this->db->select_sum($col);
        return $this->db->get_where($table, $filter)->row($col);
    }

    function _put($params, $target)
    {
        $this->db->where('token', $target);
        $user = $this->db->update('er_outlet_store', $params);
        if (!$user) return false;
        return true;
    }

    function _count()
    {
        return $this->db->count_all_results('er_outlet_store');
    }

    function _post($data)
    {
        $hash = base64_encode(random_bytes(32) . date('Hisa'));
        $hash = strtr($hash, '+/', '-_');
        $hash = rtrim($hash, '=');
        $data['token'] = $hash;
        $data['done_by'] = $this->session->userdata('prosc_user');
        if (!$this->db->insert('er_outlet_store', $data)) return false;
        return $data['token'];
    }

    function _drop($target)
    {
        $this->db->where('token', $target);
        $this->db->update('er_outlet_store', ['status' => '1']);
    }
}
