<?php
if (!defined('BASEPATH'))
  exit('No direct script access allowed');

class Online_sales_model extends CI_Model
{

  function __construct()
  {
    parent::__construct();
  }

  function _get($params)
  {
    $this->db->where('status', 0);
    $sale = $this->db->get_where('er_sales', $params);
    if (! ($sale->num_rows() > 0)) return false;
    return $this->_get_all($sale->row('voucher'));
  }

  function _get_all($voucher)
  {
    $this->db->select('er_sales.voucher, er_sales.date, er_sales.quantity, er_sales.total, er_sales.paid, er_sales.customer, er_items.name AS item, er_items.image, er_sales_extra.shipping, er_sales_extra.shipping_fee');
    $this->db->from('er_sales')->join('er_sales_extra', 'er_sales.voucher = er_sales_extra.voucher')->join('er_items', 'er_sales.item = er_items.token');
    $this->db->where(['er_sales.status' => 0, 'er_sales.voucher' => $voucher]);
    $sale = $this->db->get();
    return $sale->result_array();
  }

  function _get_delivery($cart)
  {
    $this->db->where(['voucher' => $cart]);
    $way = $this->db->get_where('er_sales', ['status' => 0]);
    if (! $way->num_rows() > 0) return [];
    return $way->row_array();
  }

  function _get_client($param)
  {
    if (! is_array($param)) $this->db->where('token', $param);
    else $this->db->where($param);

    $customer = $this->db->get('er_customers');
    if (! ($customer->num_rows() > 0)) return false;
    return $customer->row();
  }

  function _get_sales($type, $outlet = '')
  {
    if (isset($_SESSION['prosc_online_sales_x'])) {
      $datey = date('Y-m-d H:i', strtotime('+1 day', strtotime($_SESSION['prosc_online_sales_y'])));
      $this->db->where("(`er_sales.date` BETWEEN '" . $_SESSION['prosc_online_sales_x'] . "' AND '" . $datey . "')");
    } elseif (isset($_SESSION['prosc_online_sales_date']))
      $this->db->like('er_sales.date', $_SESSION['prosc_online_sales_date']);
    else
      $this->db->like('er_sales.date', date('Y-m-d'));

    $this->db->select('er_sales.token, er_sales.voucher, er_sales.date, er_sales.created_at, er_customers.name, SUM(er_sales.total) AS total');
    $this->db->from('er_sales')->join('er_customers', 'er_customers.token = er_sales.customer');
    $this->db->where([
      'er_sales.type' => 2,
      'er_sales.status' => 0
    ]);
    $this->db->group_by('voucher')->order_by('created_at DESC');

    $sales = $this->db->get();
    if (! $sales->num_rows() > 0) return [];
    return $sales->result_array();
  }

  function _get_return()
  {
    $this->db->select('er_returns.voucher, er_returns.created_at, er_customers.name, er_sales.type, er_returns.token');
    $this->db->from('er_returns')
      ->join('er_sales', 'er_returns.voucher = er_sales.voucher')
      ->join('er_customers', 'er_sales.customer = er_customers.token');
    $this->db->group_by('er_returns.voucher');
    $this->db->where([
      'er_sales.type' => 2,
      'er_sales.status' => 0,
      'er_returns.status' => 0
    ]);
    $sales = $this->db->get();
    if (! $sales->num_rows() > 0) return [];
    return $sales->result_array();
  }

  function _get_extra() {}

  function _put($params, $target, $table = 'sales')
  {
    $table = 'er_' . $table;
    if (is_array($target)) $this->db->where($target);
    else $this->db->where('token', $target);
    $user = $this->db->update($table, $params);
    if (! $user) return false;
    return true;
  }
}
