<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Order_details_model extends CI_Model
{

    function __construct()
    {
        parent::__construct();
    }


    function _get($params)
    {
        $this->db->where('status', 0);
        $user = $this->db->get_where('er_shipping', $params);
        if (!($user->num_rows() > 0)) return false;
        return $user->row();
    }


    function _get_sales($params, $return_all = false)
    {
        $this->db->where('status', 0);

        if ($return_all) {
            $user = $this->db->get_where('er_sales', ['order_status' => 'Shipment Initialized']);
            if (!($user->num_rows() > 0)) return false;
            return $user->result_array();
        } else {
            $user = $this->db->get_where('er_shipping', $params);
            if (!($user->num_rows() > 0)) return false;
            return $user->row();
        }
    }

    function _get_all()
    {
        $this->db->order_by('updated_at', 'desc');
        $users = $this->db->get_where('er_shipping', ['status' => 0]);
        if (!($users->num_rows() > 0)) return false;
        return $users->result_array();
    }

    function _get_items()
    {
        $items = $this->db->get_where('er_online_warehouse', ['status' => 0]);
        if (!($items->num_rows() > 0)) return false;
        return $items->result_array();
    }

    function _get_customers()
    {
        $this->db->where(['type' => 2]);
        $customers = $this->db->get_where('er_customers', ['status' => 0]);
        if (!($customers->num_rows() > 0)) return false;
        return $customers->result_array();
    }


    function _put_status($status, $target, $item)
    {
        if ($status === 'Shipped' or $status === 'Delivered') {
            $this->_put($status, $item);
        }
        $this->db->where(['token' => $target]);
        $user = $this->db->update('er_shipping', ['shipment_status' => $status]);
        if (!$user) return false;
        return true;
    }

    function _put($status, $item)
    {
        $this->db->where(['item' => $item]);
        $user = $this->db->update('er_sales', ['order_status' => $status]);
        if (!$user) return false;
        return true;
    }

    function _count()
    {
        $this->db->where('type !=', '0');
        return $this->db->count_all_results('er_sales');
    }

    function _drop($target)
    {
        $this->db->where('token', $target);
        $this->db->update('er_admin', ['status' => '1']);
    }
}
