<?php
if (!defined('BASEPATH'))
  exit('No direct script access allowed');

class Outlet_request_model extends CI_Model {

  function __construct() {
      parent::__construct();
  }

  function _get($params) 
  {
    $this->db->where(['status' => 0]);
    $user = $this->db->get_where('er_requests', $params);
    if ( ! ($user->num_rows() > 0)) return false;
    return $user->row();
  }

  function _get_all($params = '') 
  {
    if (!isset($_SESSION['prosc_admin'])) $this->db->where('warehouse', $_SESSION['prosc_warehouse']);
    $this->db->order_by('voucher DESC');
    if ($params != '') $this->db->where($params);
    $users = $this->db->get_where('er_requests', ['status'=>0]);
    if ( ! ($users->num_rows() > 0)) return false;
    return $users->result_array();
  }
///
  function _get_users($params = '') 
  {
    $users = $this->db->get_where('er_admin');
    if ( ! ($users->num_rows() > 0)) return false;
    return $users->result_array();
  }

  function _get_items($params = '') 
  {
    $items = $this->db->get_where('er_items', ['status'=>0]);
    if ( ! ($items->num_rows() > 0)) return false;
    return $items->result_array();
  }
  

  function _get_clients() 
  {
    $users = $this->db->get_where('er_customers', ['status'=>0, 'id >'=>1]);
    if ( ! ($users->num_rows() > 0)) return false;
    return $users->result_array();
  }

  function _put($params, $target) 
  {
    $this->db->where('token', $target);
    $user = $this->db->update('er_requests', $params);
    if ( ! $user) return false;
    return true;
  }

  function _get_outlets() 
  {
    $users = $this->db->get_where('er_warehouse', ['status'=>0]);
    if ( ! ($users->num_rows() > 0)) return false;
    return $users->result_array();
  }

  function _count()
  {
    return $this->db->count_all_results('er_requests');
  }

  function _post($data)
  {
    $hash = base64_encode(random_bytes(32).date('Hisa'));
    $hash = strtr($hash, '+/', '-_');
    $hash = rtrim($hash, '=');
    $last = $this->_count() + 1001;
    $data['token'] = $hash;
    $data['voucher'] = "#R$last";
    if ( ! $this->db->insert('er_requests', $data)) return false;
    return $data['token'];
  }
  //

  function _drop($target)
  {
    $this->db->where('token', $target);
    $this->db->update('er_requests', ['status'=>'1']);
  }
}
