<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Point_of_sales_model extends CI_Model
{

    function __construct()
    {
        parent::__construct();
    }

    function get_all_items_count()
    {
        $this->db->where('status', 0);
        $item_count = $this->db->count_all_results('er_items');
        return $item_count;
    }

    function get_random_categories_with_item_count()
    {
        // Get 5 random categories with status 0
        $this->db->where('status', 0);
        $this->db->order_by('id', 'RANDOM');
        $this->db->limit(4);
        $categories = $this->db->get('er_categories')->result();

        $result = [];

        foreach ($categories as $category) {
            // Count items in er_items table where token matches category id
            $this->db->where('category', $category->token);
            $item_count = $this->db->count_all_results('er_items');

            // Store category data and item count
            $result[] = [
                'category_name' => $category->name,
                'category_token' => $category->token,
                'item_count' => $item_count
            ];
        }

        return $result;
    }

    function get_available_items($category_token)
    {
        $this->db->select('er_items.name, er_items.token, er_items.price, er_items.image, er_categories.name AS category_name');
        $this->db->from('er_items');
        $this->db->join('er_categories', 'er_items.category = er_categories.token');
        $this->db->where('er_items.status', 0);
        $this->db->where('er_items.stock > er_items.min_stock');

        // Check if a category token is provided
        if ($category_token) {
            $this->db->where('er_items.category', $category_token);
        }

        $this->db->order_by('er_items.id', 'RANDOM');
        $this->db->limit(20);

        $query = $this->db->get();

        return $query->result();
    }
}
