<?php
if (!defined('BASEPATH'))
  exit('No direct script access allowed');

class Supply_request_model extends CI_Model
{

  function __construct()
  {
    parent::__construct();
  }

  function _get($params)
  {
    $this->db->where(['status' => 0]);
    $user = $this->db->get_where('er_requests', $params);
    if (!($user->num_rows() > 0)) return false;
    return $user->row();
  }

  function _get_all($params = '')
  {
    if ($params != '') $this->db->where($params);
    $this->db->order_by('voucher DESC');
    $users = $this->db->get_where('er_requests', ['status' => 0]);
    if (!($users->num_rows() > 0)) return false;
    return $users->result_array();
  }

  function _get_users($params = '')
  {
    if ($params != '') $this->db->where($params);
    $users = $this->db->get_where('er_admin', ['status' => 0]);
    if (!($users->num_rows() > 0)) return false;
    return $users->result_array();
  }


  function _get_states()
  {
    $users = $this->db->get_where('er_nigeria_state', ['status' => 0]);
    if (!($users->num_rows() > 0)) return false;
    return $users->result_array();
  }

  function _get_items($params = '')
  {
    $items = $this->db->get_where('er_items', ['status' => 0]);
    if (!($items->num_rows() > 0)) return false;
    return $items->result_array();
  }

  function _get_clients()
  {
    $users = $this->db->get_where('er_customers', ['status' => 0, 'id >' => 1]);
    if (!($users->num_rows() > 0)) return false;
    return $users->result_array();
  }

  function _get_price($item, $state)
  {
    $items = $this->db->get_where('er_items', ['token' => $item]);
    if (!($items->num_rows() > 0)) return 0;
    $price = json_decode($items->row('price'), true);
    return $price[$state];
  }

  function _get_quantity($item)
  {
    $items = $this->db->get_where('er_online_warehouse', ['token' => $item]);
    if (!($items->num_rows() > 0)) return 0;
    return $items->row('stock');
  }

  function _get_outlet($params)
  {
    $data = $this->db->get_where('er_warehouse', $params);
    if (!($data->num_rows() > 0)) return false;
    return $data->row();
  }

  function _get_voucher()
  {
    $this->db->group_by('voucher');
    $uuid = $this->db->count_all_results('er_supply') + 10010001;
    return $uuid;
  }

  function _get_key()
  {
    $hash = base64_encode(random_bytes(32) . date('Hisa'));
    $hash = strtr($hash, '+/', '-_');
    $hash = rtrim($hash, '=');
    return $hash;
  }

  function _put($params, $target)
  {
    $this->db->where('token', $target);
    $user = $this->db->update('er_requests', $params);
    if (!$user) return false;
    return true;
  }

  function _get_outlets()
  {
    $users = $this->db->get_where('er_warehouse', ['status' => 0]);
    if (!($users->num_rows() > 0)) return false;
    return $users->result_array();
  }

  function _count()
  {
    return $this->db->count_all_results('er_requests');
  }

  function _post($data)
  {
    $hash = base64_encode(random_bytes(32) . date('Hisa'));
    $hash = strtr($hash, '+/', '-_');
    $hash = rtrim($hash, '=');
    $last = $this->_count() + 1;
    $uuid = str_repeat('0', 3 - strlen($last)) . $last;
    $data['token'] = $hash;
    if (!$this->db->insert('er_requests', $data)) return false;
    return $data['token'];
  }

  function _post_supply($data)
  {
    if (!$this->db->insert_batch('er_supply', $data)) return false;
    return true;
  }

  function _put_warehouse($data)
  {
    if (!$this->db->update_batch('er_online_warehouse', $data, 'token')) return false;
    return true;
  }

  function _drop($target)
  {
    $this->db->where('token', $target);
    $this->db->update('er_requests', ['status' => '1']);
  }
}
