<?php defined('BASEPATH') OR exit('No direct script access allowed'); ?>
<?php if (is_array($data)) { ?>
<div class="px-2 px-md-4 banner d-print-none">
  <div class="pb-2 crumb">
    <img src="<?= base_url('assets/images/favicon.png'); ?>" width="40px"><i class="ix ix-chevron"></i>
    <a href="<?= base_url('ipanel/customers.aspx'); ?>">Clients</a><i class="ix ix-chevron"></i>
    <a href="javascript:void(0)">Supply History</a>
  </div>
  <div class="pb-2 ms-auto">
    <div class="btn-group bg-light rounded px-2">
      <button class="btn" onclick="$('#search').focus()"><i class="bi-search"></i></button>
      <a href="<?= base_url('filter/'.$page) ?>" class="btn" data-title="Filter" data-bs-toggle="modal" data-bs-target="#mModal" ><i class="bi-filter"></i></a>
    </div>
    <a class="btn btn-supreme rounded-0" id="download2x" onclick="window.print()">
      <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-cloud-arrow-down-fill" viewBox="0 0 16 16">
        <path d="M8 2a5.53 5.53 0 0 0-3.594 1.342c-.766.66-1.321 1.52-1.464 2.383C1.266 6.095 0 7.555 0 9.318 0 11.366 1.708 13 3.781 13h8.906C14.502 13 16 11.57 16 9.773c0-1.636-1.242-2.969-2.834-3.194C12.923 3.999 10.69 2 8 2zm2.354 6.854-2 2a.5.5 0 0 1-.708 0l-2-2a.5.5 0 1 1 .708-.708L7.5 9.293V5.5a.5.5 0 0 1 1 0v3.793l1.146-1.147a.5.5 0 0 1 .708.708z"/>
      </svg> Download
    </a>
  </div>
</div>
<div class="banner p-3">
  <div><b><?= $client['name'] ?></b><br /><b><?= $client['phone'] ?></b></div>
  <table class="text-end">
    <tr><td><b>Total Supplies: &nbsp; </b></td><td><b><span class="money"><?= number_format($balances['supply']) ?></span></b></td></tr>
    <tr><td><b>Total Payment Received: &nbsp; </b></td><td><b><span class="money"><?= number_format($balances['payment']) ?></span></b></td></tr>
  </table>
</div>
<div class="container-fluid pt-3">
  <div class="table-responsive text-nowrap">
    <table class="table<?= (count($data) > 0) ? ' table-hovers' : ''; ?>">
      <thead>
        <tr>
          <th class="text-center" width="20px">#</th>
          <th>Voucher</th>
          <th>Supply Total</th>
          <th>Payment</th>
          <th>Date</th>
          <th class="text-center" width="20px"></th>
        </tr>
      </thead>
      <tbody id="drop-off">
    <?php
      $c = 0;
      foreach ($data as $row) { 
        $c++;
        $left = '+'. $client['days'] .' days';
        $left = strtotime($left, strtotime($row['date'])) - time();
        $left = intval($left / 86400);
        $days = (array_key_exists($row['voucher'], $payment) && ($row['total'] - $payment[$row['voucher']] <= 0));
        // $span = $days ? 'text-bg-secondary' : 'text-bg-danger';
        // $text = $days ? 'Completed' : ($left .' Days Left');
        $text = $days ? '<span class="badge text-bg-success">Completed</span>' : ('<span class="money">'. number_format($payment[$row['voucher']]) .'</span>');
    ?>
        <tr>
          <td width="20px" class="text-end"><?= $c; ?></td>
          <td><?= $row['voucher']; ?></td>
          <td><span class="money"><?= number_format($row['total']); ?></span></td>
          <td><?= $text ?></td>
          <td><?= date('d/m/Y', strtotime($row['date'])); ?></td>
          <td class="dropstart py-2">
            <button class="btn btn-sm" data-bs-toggle="dropdown"><i class="bi-three-dots-vertical"></i></button>
            <div class="dropdown-menu">
              <a href="<?= base_url('ipanel/payment.aspx?voucher='.$row['voucher']); ?>" class="dropdown-item"><i class="bi-cash"></i> Payment Tracking</a>
              <a href="<?= base_url('generate/invoice.aspx?action=supply&target='.$row['token']); ?>" class="dropdown-item" title="Generate Invoice"><i class="bi-clipboard2-check-fill"></i>Generate Invoice</a>
            </div>
          </td>
        </tr>
    <?php } ?>
    <?php if (count($data) == 0) { ?>
        <tr><td colspan="6" class="p-5 text-danger text-center">no data available</td></tr>
    <?php } ?>
      </tbody>
    </table>
  </div>
</div>
<?php } ?>
