<?php defined('BASEPATH') or exit('No direct script access allowed');
$sum_supply = $sum_expense = $sum_sales = $sum_total = 0;

$client = $outlet = [];
foreach ($clients as $key) $client[$key['token']] = [$key['days'], $key['name']];
foreach ($outlets as $key) $outlet[$key['token']] = $key['name'];
foreach (json_decode($totals) as $key) $sum_total += $key;
foreach (json_decode($sales) as $key) $sum_sales += $key;
foreach (json_decode($supply) as $key) $sum_supply += $key;
foreach (json_decode($expenses) as $key) $sum_expense += $key;
$chart = $_SESSION['chart_toggle'] ?? 'yearly';
$chart = ($chart == 'monthly') ? 'Monthly' : 'Yearly';
?>

<div class="container-fluid bg-white align-items-center mx-auto p-3 d-flex justify-content-between" style="width: calc(100% - 48px)">
  <h5 class="mb-0"><b>Hi <?= explode(' ', $this->session->userdata('prosc_name'))[0] ?>,</b> </h5>
  <div class="align-items-center d-none d-md-flex">
    <span class="px-2 text-nowrap">Time Period</span>
    <div class="dropdown">
      <button class="btn rounded dropdown-toggle btn-outline-supreme-2" data-bs-toggle="dropdown"><?= $chart; ?></button>
      <div class="dropdown-menu">
        <a href="javascript:void(0)" data-ref="<?= base_url('ipanel?chart_toggle=monthly'); ?>" class="sub-url dropdown-item">Monthly</a>
        <a href="javascript:void(0)" data-ref="<?= base_url('ipanel?chart_toggle=yearly'); ?>" class="sub-url dropdown-item">Yearly</a>
      </div>
    </div>
  </div>
</div>
<div class="container-fluid px-4">
  <div class="row">
    <div class="col-lg-8">
      <div class="row pt-3 pb-2">
        <div class="col-md-6">
          <div class="save-pill cast" id="total" onclick="total()">
            <div class="line-text border-bottom">
              <span><i class="bi-cash"></i> SALES </span>
              <!-- <i class="bi-three-dots-vertical"></i> -->
            </div>
            <div class="amount">
              <?php if ($currency == "GBP"): ?>
                <i class="bi bi-currency-pound"></i><?= number_format($sum_sales); ?>
              <?php else: ?>
                <span class="money"><?= number_format($sum_sales); ?></span>
              <?php endif; ?>


              <!-- <span class="tip text-danger"><i class="bi-chevron-down"></i>3%</span> -->
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="save-pill cast" id="xpense" onclick="expenses()">
            <div class="line-text border-bottom">
              <span><i class="bi-coin text-supreme"></i> EXPENSES</span>
              <!-- <i class="bi-three-dots-vertical"></i> -->
            </div>
            <div class="amount">
              <?php if ($currency == "GBP"): ?>
                <i class="bi bi-currency-pound"></i><?= number_format($sum_expense); ?>
              <?php else: ?>
                <span class="money"><?= number_format($sum_expense); ?></span>
              <?php endif; ?>

              <!-- <span class="tip text-success"><i class="bi-chevron-up"></i>3%</span> -->
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="save-pill cast" id="supply" onclick="supply_data()">
            <div class="line-text border-bottom">
              <span><i class="bi-cash text-supreme"></i> SUPPLY</span>
              <!-- <i class="bi-three-dots-vertical"></i> -->
            </div>
            <div class="amount">
              <?php if ($currency == "GBP"): ?>
                <i class="bi bi-currency-pound"></i><?= number_format($sum_supply); ?>
              <?php else: ?>
                <span class="money"><?= number_format($sum_supply); ?></span>
              <?php endif; ?>

              <!-- <span class="tip text-success"><i class="bi-chevron-up"></i>3%</span> -->
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="save-pill cast">
            <div class="line-text border-bottom">
              <span><i class="bi-box-fill text-supreme"></i> PENDING ORDERS</span>
            </div>
            <div class="amount"><?= number_format($pending); ?></div>
          </div>
        </div>
      </div>
      <!-- chart start -->
      <div class="container py-3 bg-white rounded cast mb-3">
        <h5 id="chart-title" class="p-3"><b>Total Sales</b></h5>
        <div style="height: 320px">
          <canvas id="chart"></canvas>
        </div>
      </div>
      <!-- chart end -->
      <div class="container-fluid bg-white rounded cast">
        <div class="d-flex justify-content-between px-1 py-3">
          <h5>Supply request</h5>
          <a class="text-supreme" href="<?= base_url('ipanel/' . ((isset($_SESSION['prosc_admin'])) ? 'admin' : 'outlet') . '_request.aspx'); ?>">See All <i class="ix ix-chevron"></i></a>
        </div>
        <div class="table-responsive" style="min-height: 0">
          <table class="table table-hovers">
            <thead>
              <tr>
                <th>#</th>
                <th>Order ID</th>
                <th>Recipient</th>
                <th>Items</th>
                <th width="60px" class="text-center">Price</th>
                <th>Date</th>
                <th width="60px">Status</th>
              </tr>
            </thead>
            <tbody>
              <?php
              $c = 0;;
              foreach ($orders as $row) :
                $c++;
                $tag = ($row['approve'] == 0) ? 'primary' : (($row['approve'] == 1) ? 'success' : 'light');
                $status = $row['approve'] == 0 ? 'Awaiting approval' : ($row['approve'] == 1 ? '<i class="bi-check2"></i> Approved' : '<i class="bi-x-lg"></i> Completed');
              ?>
                <tr>
                  <td><?= $c; ?></td>
                  <td><b>#<?= 1001 + $row['requests_id']; ?></b></td>
                  <td><?= $outlet[$row['warehouse']] ? $outlet[$row['warehouse']] : 'Online warehouse' ?></td>
                  <td><?= $row['items']; ?></td>
                  <td class="text-end text-nowrap">
                    <?php if ($currency == "GBP"): ?>
                      <i class="bi bi-currency-pound"></i><?= number_format($row['total'], 2); ?>
                    <?php else: ?>
                      <span class="money"><?= number_format($row['total'], 2) ?></span>
                    <?php endif; ?>
                  </td>
                  <td><?= date('d M, Y', strtotime($row['created_at'])); ?></td>
                  <td class="text-nowrap"><span class="badge text-bg-<?= $tag ?>"><?= $status; ?></span></td>
                </tr>
              <?php endforeach ?>
            </tbody>
          </table>
        </div>
      </div>
    </div>
    <div class="col-lg-4 py-3">
      <div class="save-pill cast">
        <div class="line-text border-bottom">
          <span><i class="bi-person-lines-fill text-supreme"></i> CUSTOMERS</span>
        </div>
        <div class="amount"><?= number_format(count($clients)); ?></div>
      </div>
      <div class="container bg-white p-3 mb-3 rounded cast">
        <h5 class="d-flex justify-content-between align-items-center" style="font-size: 1.1rem;"><b>Staff Sales Performance </b>
          <a href="<?= base_url('ipanel/users.aspx') ?>" class="btn bg-white text-nowrap btn-sm pe-0 text-supreme">See all <i class="ix ix-chevron"></i></a>
        </h5>
        <?php if (count($staff_sales) > 0) { ?>
          <?php foreach ($staff_sales as $row) { ?>
            <div class="d-flex justify-content-between p-2 border mb-2 rounded">
              <div>
                <span><?= $outlet[$row['outlet']] ?></span><br />
                <b><?= $row['staff'] ?></b>
              </div>
              <div class="text-end">


                <?php if ($currency == "GBP"): ?>
                  <i class="bi bi-currency-pound"></i><?= number_format($row['total']); ?>
                <?php else: ?>
                  <b class="money"><?= number_format($row['total']) ?></b>
                <?php endif; ?>
                <!-- <span><?= $row['statement'] ?></span> -->
              </div>
            </div>
          <?php } ?>
        <?php
        } else {
        ?>
          <div class="p-5 text-center">
            <i class="bi-archive-fill bi-3x text-danger"></i><br><br>
            <span class="bi-2x">No data available</span>
          </div>
        <?php } ?>
      </div>
      <div class="container bg-white p-0 rounded cast">
        <h5 class="d-flex justify-content-between px-3 pt-2 pb-1 border-bottom mb-0 align-items-center"><b>Income Statement </b>
          <!-- <a href="<?= base_url('ipanel/supply_client.aspx') ?>" class="btn bg-white m-0 pe-0 text-supreme">See all <i class="ix ix-chevron"></i></a> -->
        </h5>
        <div class="border-bottom border-top p-3">
          <canvas id="pie-chart"></canvas>
          <div class="d-flex justify-content-around p-3">
            <span><i class="bi-circle-fill text-success text-sm mt-1"></i> Sales</span>
            <span><i class="bi-circle-fill text-danger text-sm mt-1"></i> Expenses</span>
          </div>
        </div>
        <div class="d-flex justify-content-between border-bottom p-3">
          <div>
            <span class="text-secondary">Sales</span>
            <div>
              <?php if ($currency == "GBP"): ?>
                <i class="bi bi-currency-pound"></i><?= number_format($sum_sales); ?>
              <?php else: ?>
                <b class="money"><?= number_format($sum_sales); ?></b>
              <?php endif; ?>

            </div>
          </div>
          <div>
            <span class="text-secondary">PROFIT</span>
            <div>

              <?php if ($currency == "GBP"): ?>
                <i class="bi bi-currency-pound"></i><?= number_format($sum_sales - $sum_expense); ?>
              <?php else: ?>
                <b class="money"><?= number_format($sum_sales - $sum_expense); ?></b>
              <?php endif; ?>
            </div>
          </div>
        </div>
        <div class="p-3">
          <span class="text-secondary">Expenses</span>
          <div>
            <?php if ($currency == "GBP"): ?>
              <i class="bi bi-currency-pound"></i><?= number_format($sum_expense); ?>
            <?php else: ?>
              <b class="money"><?= number_format($sum_expense); ?></b>
            <?php endif; ?>

          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<style type="text/css">
  .bgs {
    background-color: transparent !important;
  }

  .cast {
    box-shadow: 0px 2px 10px 0px rgba(51, 51, 51, 0.05);
  }

  .line-text {
    font-weight: bold;
  }
</style>
<script type="text/javascript">
  let supplies = <?= $supply ?>;
  let xpenses = <?= $expenses ?>;
  let totals = <?= $sales ?>;
  let sumsales = <?= $sum_sales ?>;
  let sumexpense = <?= $sum_expense ?>;
  let pending = '<?= $pending ?>';
  let approved = '<?= $approved ?>';
  let declined = '<?= $declined ?>';
  let currency = '<?= $currency ?>';
</script>
<script src="https://cdn.jsdelivr.net/npm/chart.js@2.9.3/dist/Chart.min.js"></script>
<script type="text/javascript" src="<?= base_url('assets/js/awe-stats.js'); ?>" defer></script>