<?php defined('BASEPATH') or exit('No direct script access allowed'); ?>

<section class="pos_main">
    <div class="pos_main_1 gap-2">
        <div class="pos_main_1_nav">
            <section class="p-3 bg-light text-dark rounded-3"><i class="bi bi-calendar-date text-success fs-5"></i>
                <span class="fs-5" id="date"></span>
            </section>
            <a href="sales.aspx" class="p-3 bg-light text-dark rounded-3 fs-5 fa_cursor_pointer">Sales history</a>
            <a href="<?= base_url('ipanel/pop/point_of_sales'); ?>" style="display: none;" id="recipt-pop" data-bs-toggle="modal" data-bs-target="#mModal" data-title="Print receipt"><i class="bi-plus-lg"></i> Assign POS</a>

            <a href="" class="text-decoration-none ">
                <section class="p-3 cursor-pointer bg-light text-dark rounded-3 fa_cursor_pointer">
                    <a href="<?= base_url("/pos"); ?>" target="_blank" class="text-decoration-none "><span class="fs-5">Open customer sales</span></a>
                </section>
            </a>
        </div>
        <div class="pos_main_1_cat">
            <a href="point_of_sales.aspx" class="text-decoration-none a_pos">

                <div class="pos_main_1_cat_item bg-light rounded-5 p-3">
                    <span class="fs-6 fw-bold">Xcel</span>
                    <div class="pos_main_1_cat_item_span">
                        <span class="fs-6 mb-1">All items</span>
                        <span class="fs-6" style="color: gray;"><?= $data[3] ?> item(s)</span>
                    </div>
                </div>
            </a>
            <?php
            foreach ($data[0] as $row) {
            ?>
                <a href="point_of_sales.aspx?category=<?= urlencode($row['category_token']) ?>" class="text-decoration-none a_pos">
                    <div class="pos_main_1_cat_item bg-light rounded-5 p-3">
                        <span class="p-3 rounded-circle border fw-bold text-center" style="width: 60px;">
                            <?= substr($row['category_name'], 0, 1) ?>
                        </span>
                        <div class="pos_main_1_cat_item_span">
                            <span class="fs-6 mb-1 fw-bold"><?= $row['category_name'] ?></span>
                            <span class="fs-6" style="color: gray;"><?= $row['item_count'] ?> item(s)</span>
                        </div>
                    </div>
                </a>
            <?php } ?>

        </div>

        <form action="" class="pos_main_1_search p-3">
            <input type="text" placeholder="Seach product" class="pos_main_1_search_input rounded-5 p-3">
            <button type="submit" class="p-2 rounded-circle  pos_main_1_search_btn"><i class="bi bi-search fs-4"></i></button>
        </form>

        <div class="pos_main_1_products p-3 d-flex gap-5">
            <?php
            foreach ($data[1] as $row) {
                $price = json_decode($row->price, true) ?? ['a577f519b58b533e400cf28a7464576babf92121' => [0, 0]];
                $price = $price['a577f519b58b533e400cf28a7464576babf92121'];
            ?>
                <section
                    class="pos_main_1_products_div p-2 rounded-3 border bg-light"
                    onclick="handleItemClick({
            name: '<?= addslashes($row->name) ?>',
            price: <?= $price[1] ?>,
            image: '<?= addslashes($row->image) ?>',
            category: '<?= addslashes($row->category_name) ?>',
            token: '<?= addslashes($row->token) ?>'
        })">
                    <img
                        class="pos_main_1_products_div_img"
                        src="<?= $row->image; ?>"
                        class="img-fluid"
                        alt="<?= $row->name ?>"
                        width="100%"
                        height="180xp">
                    <div class="p-1 fs-6"><?= $row->name ?></div>
                    <div class="pos_main_1_products_price">
                        <span class="p-1 bg-info text-dark rounded-3"><?= $row->category_name ?></span>

                        <?php if ($data[3] == "GBP"): ?>
                            <i class="bi bi-currency-pound"></i> <span class="fs-6"><?= number_format($price[1], 1); ?></span>
                        <?php else: ?>
                            <span class="money fs-6"><?= number_format($price[1], 1); ?></span>
                        <?php endif; ?>
                    </div>
                </section>
            <?php } ?>
        </div>
    </div>
    <div class="pos_main_2 d-flex justify-content-between">
        <!-- Left Section: Order Details -->
        <section class="w-100 d-flex gap-3 h-75" style="overflow-x: auto; flex-direction: column; align-items: center;">
            <!-- Order Details Header -->
            <section class="p-3 w-100 bg-light text-center fs-5">Order details</section>

            <!-- Order Details Content -->
            <section class="pos_main_2_details p-3 w-100 fs-6">
                <section id="total_items_box">
                    No item selected
                </section>
                <section>
                    <span class="text-danger fs-6 cursor-pointer" onclick="clearAll()">Clear all</span>
                </section>
            </section>

            <!-- Selected Items -->
            <main class="p-3 w-100">
                <div id="selected-items-container" class="w-100">
                    <!-- Dynamically generated items will appear here -->
                </div>
            </main>
        </section>

        <!-- Right Section: Subtotal, Tax, Total -->
        <section class="w-100 d-flex flex-column gap-3 h-25 p-1">
            <div class="w-100 d-flex flex-column gap-1">
                <section class="w-100 d-flex align-items-center justify-content-between gap-2" style="height: 30px; border-bottom: 2px dotted rgb(119, 119, 119);">
                    <span>Subtotal</span>
                    <?php if ($data[3] == "GBP"): ?>
                        <i class="bi bi-currency-pound"></i> <span id="subtotal">0</span>
                    <?php else: ?>
                        <span class="money"><span id="subtotal">0</span></span>
                    <?php endif; ?>

                </section>
                <section class="w-100 d-flex align-items-center justify-content-between gap-2" style="height: 30px; border-bottom: 2px dotted rgb(119, 119, 119);">
                    <span>Tax</span>
                    <span id="tax">0</span>
                </section>
                <section class="w-100 d-flex align-items-center justify-content-between gap-2" style="height: 30px; border-bottom: 2px dotted rgb(119, 119, 119);">
                    <span>Total</span>
                    <?php if ($data[3] == "GBP"): ?>
                        <i class="bi bi-currency-pound"></i> <span id="total">0</span>
                    <?php else: ?>
                        <span class="money"><span id="total">0</span></span>
                    <?php endif; ?>

                </section>
            </div>

            <!-- Payment Method -->
            <form action="" class="w-100">

                <select class="form-select" name="payment_method" required>
                    <option value="cash">Cash</option>
                    <option value="transfer">Transfer</option>
                    <option value="pos">POS</option>
                </select>
            </form>

            <!-- Pay Now Button -->
            <button id="pay-now-btn" class="btn btn-supreme d-flex align-items-center justify-content-center gap-2">
                <span>Pay now</span>
                <div id="loading-spinner" class="spinner-border spinner-border-sm text-light" role="status" style="display: none;">
                    <span class="visually-hidden">Loading...</span>
                </div>
            </button>


        </section>
    </div>

    <script>
        const options = {
            weekday: 'short',
            day: '2-digit',
            month: 'short',
            year: 'numeric'
        };
        const currentDate = new Date().toLocaleDateString('en-US', options).replace(',', '');
        const date = document.getElementById('date');
        date.innerHTML = ''; // Clear the container

        date.innerHTML = `<span>${currentDate}</span>`;

        // Initialize an empty array to store selected items
        let selectedItems = [];
        const TAX_RATE = 0.05; // Example: 5% tax rate

        // Load items from local storage on page load
        window.onload = function() {
            const savedItems = localStorage.getItem('selectedItems');
            if (savedItems) {
                selectedItems = JSON.parse(savedItems);
                renderSelectedItems(); // Render saved items if they exist
                console.log("Loaded items from local storage:", selectedItems);
            }
        };

        // Function to save the selected items array to local storage
        function saveToLocalStorage() {
            localStorage.setItem('selectedItems', JSON.stringify(selectedItems));
            console.log("Items saved to local storage:", selectedItems);
        }

        // Function to handle item click
        function handleItemClick(item) {
            const exists = selectedItems.some(selected => selected.token === item.token);

            if (!exists) {
                selectedItems.push({
                    ...item,
                    quantity: 1
                }); // Add item with an initial quantity of 1
                saveToLocalStorage(); // Save updates to local storage
                renderSelectedItems();
                console.log("Item added:", selectedItems);
            } else {
                console.log("Item already added:", item);
            }
        }

        // Function to render the selected items
        function renderSelectedItems() {
            const container = document.getElementById('selected-items-container');
            const totalItemsBox = document.getElementById('total_items_box');
            container.innerHTML = ''; // Clear the container

            if (selectedItems.length === 0) {
                totalItemsBox.innerHTML = "No item selected";
                updateTotals();
                return;
            }

            totalItemsBox.innerHTML = `<span>${selectedItems.length} item(s) selected</span>`;

            selectedItems.forEach(item => {
                const itemHTML = `
                <div class="w-100 pos_main_2_details_item">
                    <section class="p-3 w-25 bg-light d-flex align-items-center justify-content-center">
                        <img src="${item.image}" width="80%" height="80%">
                    </section>
                    <section class="p-2 w-75 d-flex flex-column gap-2">
                        <div class="w-100 d-flex align-items-center justify-content-between">
                            <span class="fw-bold">${item.name}</span>
                            <i class="bi bi-x-circle fs-4" onclick="removeItem('${item.token}')"></i>
                        </div>
                        <div class="w-25 d-flex p-1 bg-info rounded-3">${item.category}</div>
                        <div class="w-100 d-flex align-items-center justify-content-between">
                            <div class="card__counter bg-light">
                                <button class="card__btn" onclick="decrementItem('${item.token}')">-</button>
                                <div class="card__counter-score" id="counter-${item.token}">${item.quantity}</div>
                                <button class="card__btn card__btn-plus" onclick="incrementItem('${item.token}')">+</button>
                            </div>
                             <?php if ($data[3] == "GBP"): ?>
                        <i class="bi bi-currency-pound"></i>  <span class="fw-bold">${Number(item.price * item.quantity).toLocaleString()}</span>
                    <?php else: ?>
                        <span class="money"> <span class="fw-bold">${Number(item.price * item.quantity).toLocaleString()}</span></span>
                    <?php endif; ?>
                           
                        </div>
                    </section>
                </div>
            `;
                container.innerHTML += itemHTML;
            });

            updateTotals(); // Update totals dynamically
        }

        // Function to remove an item by its token
        function removeItem(token) {
            selectedItems = selectedItems.filter(item => item.token !== token);
            saveToLocalStorage(); // Save updates to local storage
            renderSelectedItems();
            console.log("Item removed:", token);
        }

        // Function to increment the quantity of an item
        function incrementItem(token) {
            const item = selectedItems.find(item => item.token === token);
            if (item) {
                item.quantity += 1;
                saveToLocalStorage(); // Save updates to local storage
                renderSelectedItems();
            }
        }

        // Function to decrement the quantity of an item
        function decrementItem(token) {
            const item = selectedItems.find(item => item.token === token);
            if (item && item.quantity > 1) {
                item.quantity -= 1;
                saveToLocalStorage(); // Save updates to local storage
                renderSelectedItems();
            }
        }

        // Function to update subtotal, tax, and total
        function updateTotals() {
            const subtotal = selectedItems.reduce((sum, item) => sum + item.price * item.quantity, 0);
            const tax = subtotal * TAX_RATE;
            const total = subtotal + tax;

            document.getElementById('subtotal').textContent = subtotal.toLocaleString();
            document.getElementById('tax').textContent = tax.toLocaleString();
            document.getElementById('total').textContent = total.toLocaleString();
        }

        // Function to clear all items
        function clearAll() {
            selectedItems = [];
            saveToLocalStorage(); // Save updates to local storage
            renderSelectedItems();
            console.log("All items cleared");
        }
        document.getElementById('pay-now-btn').addEventListener('click', function(event) {
            event.preventDefault();

            const button = document.getElementById('pay-now-btn');
            const spinner = document.getElementById('loading-spinner');
            const paymentMethod = document.querySelector('select[name="payment_method"]').value;

            // Gather selected items
            const selectedItems = JSON.parse(localStorage.getItem('selectedItems')) || [];
            if (selectedItems.length === 0) {
                alert('No items selected for payment.');
                return;
            }

            // Prepare payload
            const payload = {
                items: selectedItems,
                payment_method: paymentMethod,
                subtotal: document.getElementById('subtotal').textContent,
                tax: document.getElementById('tax').textContent,
                total: document.getElementById('total').textContent
            };

            const pop_up = document.getElementById('recipt-pop');

            // Show spinner and disable button
            button.disabled = true;
            spinner.style.display = 'inline-block';

            // Send to backend
            fetch('<?= base_url("ipanel/post/point_of_sales"); ?>', {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    body: JSON.stringify(payload),
                })
                .then(response => response.json())
                .then(data => {
                    if (data.status === 'success') {
                        alert('Payment completed successfully!');
                        localStorage.removeItem('selectedItems'); // Clear items
                        pop_up.click();
                    } else {
                        alert(data.message || 'An error occurred during payment.');
                    }
                })
                .catch(error => {
                    console.error('Error:', error);
                    alert('An error occurred during payment.');
                })
                .finally(() => {
                    // Hide spinner and enable button
                    button.disabled = false;
                    spinner.style.display = 'none';
                });
        });
    </script>
</section>

<?php ?>