var ctx = document.getElementById("chart").getContext("2d");
var gradient = ctx.createLinearGradient(0, 0, 0, 400);
function grad(s1, s2) {
  gradient = ctx.createLinearGradient(0, 0, 0, 400);
  gradient.addColorStop(0, s1);
  gradient.addColorStop(1, s2);
  return gradient;
}
options = {
  layout: { padding: 10 },
  responsive: true,
  maintainAspectRatio: false,
  interaction: { mode: "nearest" },
  legend: { display: false },
  scales: {
    xAxes: [
      {
        gridLines: { display: false },
        ticks: {
          padding: 10,
          autoSkip: false,
        },
      },
    ],
    yAxes: [
      {
        scaleLabel: { display: false },
        gridLines: { display: false },
        ticks: {
          beginAtZero: false,
          maxTicksLimit: 6,
          padding: 10,
          callback: function (value, index, values) {
            if (parseInt(value) >= 1000) {
              if (currency === "GBP") {
                return (
                  "£ " + value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",")
                );
              } else {
                return (
                  "₦ " + value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",")
                );
              }
            } else {
              if (currency === "GBP") {
                return "£ " + value;
              } else {
                return "₦ " + value;
              }
            }
          },
        },
      },
    ],
  },
};

function pillToggle(me, title) {
  $(".save-pill").removeClass("active");
  me.addClass("active");
  $("#chart-title b").text(title);
}

function total() {
  pillToggle($("#total"), "Sales");
  const data1 = [totals];

  data2 = data1.map((row) => Object.keys(row));
  data3 = data1.map((row) => Object.values(row));
  new Chart(document.getElementById("chart"), {
    type: "line",
    data: {
      labels: data2[0],
      datasets: [
        {
          fill: true,
          backgroundColor: grad("rgba(174,250,50,.2)", "rgba(174,250,50,0)"),
          pointBackgroundColor: "#54B81B",
          borderColor: "#54B81B",
          lineTension: 0.25,
          borderWidth: 2,
          pointStyle: "cross",
          pointRadius: 2,
          label: "Total Revenue",
          data: data3[0],
        },
      ],
    },
    options,
  });
}

function supply_data() {
  pillToggle($("#supply"), "Supply");
  const data1 = [supplies];

  data2 = data1.map((row) => Object.keys(row));
  data3 = data1.map((row) => Object.values(row));
  new Chart(document.getElementById("chart"), {
    type: "line",
    data: {
      labels: data2[0],
      datasets: [
        {
          fill: true,
          backgroundColor: grad(
            "rgba(184, 84, 27, .1)",
            "rgba(184, 84, 27, 0)"
          ),
          pointBackgroundColor: "#B8541B",
          borderColor: "#B8541B",
          lineTension: 0.25,
          borderWidth: 2,
          pointRadius: 0.5,
          label: "Supply",
          data: data3[0],
        },
      ],
    },
    options,
  });
}

function expenses() {
  pillToggle($("#xpense"), "Expenses");
  const data1 = [xpenses];

  data2 = data1.map((row) => Object.keys(row));
  data3 = data1.map((row) => Object.values(row));
  new Chart(document.getElementById("chart"), {
    type: "line",
    data: {
      labels: data2[0],
      datasets: [
        {
          fill: true,
          backgroundColor: grad(
            "rgba(184, 84, 27, .1)",
            "rgba(184, 84, 27, 0)"
          ),
          pointBackgroundColor: "#B8541B",
          borderColor: "#B8541B",
          lineTension: 0.25,
          borderWidth: 2,
          pointRadius: 0.5,
          label: "Expenses",
          data: data3[0],
        },
      ],
    },
    options,
  });
}

var ctx2 = document.getElementById("pie-chart").getContext("2d");
data = {
  datasets: [
    {
      data: [sumsales, sumexpense],
      backgroundColor: ["#05941D", "#FF5648"],
      borderWidth: 0,
    },
  ],
  labels: ["Sales", "Expenses"],
};
var myDoughnutChart = new Chart(ctx2, {
  type: "doughnut",
  data: data,
  options: {
    cutoutPercentage: 70,
    legend: false,
  },
});
window.onload = total;
