let options = {
  scales: {
    y: {
      grace: '10%',
      title: {
        display: true,
        text: 'Quantity Sold',
        beginAtZero: true
      }
    }
  }, 
  plugins: {
    legend: {display: false},
  },
  maintainAspectRatio: false,
}

function pillToggle(me, title) {
  $('.save-pill').removeClass('active');
  me.addClass('active');
  $('#chart-title b').text(title);
}

function runner() {
  let data1 = [JSON.parse(lowests)];
  data3 = data1.map(row => Object.values(row).map(val => val['quantity']));
  data2 = data1.map(row => Object.values(row).map(val => [val['item'], val['price'].toLocaleString()]));
  new Chart(
    document.getElementById('charted2'),
    {
      type: 'bar',
      data: {
        labels: data2[0],
        datasets: [
          {
            fill: true,
            backgroundColor: '#ff5648',
            label: 'Sales',
            data: data3[0],
            borderRadius: 15,
            barThickness: 60
          }
        ]
      }, options: options
    }
  );
  
  data1 = [JSON.parse(highests)];
  data3 = data1.map(row => Object.values(row).map(val => val['quantity']));
  data2 = data1.map(row => Object.values(row).map(val => [val['item'], val['price'].toLocaleString()]));
  new Chart(
    document.getElementById('charted'),
    {
      type: 'bar',
      data: {
        labels: data2[0],
        datasets: [
          {
            fill: true,
            backgroundColor: '#05941d',
            label: 'Sales',
            data: data3[0],
            borderRadius: 15,
            barThickness: 60
          }
        ]
      }, options: options
    }
  );
}

function highest() {
  $('#lowest').removeClass('btn-outline-supreme-2');
  $('#highest').addClass('btn-outline-supreme-2');
  $('#charted').removeClass('d-none');
  $('#charted2').addClass('d-none');
  pillToggle($('#highest'), 'Top 5 Sales');
}

function lowest() {
  $('#lowest').addClass('btn-outline-supreme-2');
  $('#highest').removeClass('btn-outline-supreme-2');
  $('#charted').addClass('d-none');
  $('#charted2').removeClass('d-none');
  pillToggle($('#lowest'), 'Lowest 5 Sales');
}

runner();
